/* --- The following code comes from c:\lcc\lib\wizard\textmode.tpl. */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
void Usage(char *programName)
{
	fprintf(stderr,"%s <infilename> usage:\n",programName);
	fprintf(stderr,"Strips 8th bit from all chars in input file.\n");
	fprintf(stderr,"minor processing of other WS tags \n");
	fprintf(stderr,"outfilename is infilename+.8.\n");
	fprintf(stderr,"not implemented: asks before overwriting output file\n");
	fprintf(stderr,"Used to strip Wordstar bit.\n");
	fprintf(stderr,"%s -h prints this message.\n", programName);
	return;
}

/* returns the number of arguments up to two */
int HandleOptions(int argc,char *argv[])
{
	int i,options=0;

	for (i=1; i< argc;i++) {
		if (argv[i][0] == '/' || argv[i][0] == '-') {
			switch (argv[i][1]) {
				/* An argument -? means help is requested */
				case '?':
					Usage(argv[0]);
					return -1;
					break;
				case 'h':
				case 'H':
					if (!stricmp(argv[i]+1,"help")) {
						Usage(argv[0]);
						return -1;
						break;
					}

				default:
					fprintf(stderr,"unknown option %s\n",argv[i]);
					Usage(argv[0]);
					return -1;
					break;
			}
		}
		else { /* string is filename or number want exactly two */
			if (options==0) options++;
			else {
				fprintf(stderr, "too many arguments\n");
				return -1;
			}
		}
	}
	if (options != 1) {
		fprintf(stderr, "too few arguments\n");
		return -1;
	}
	return options; /* only returns 2 if successful */
}

int printbuf(char buffer[], int cols, FILE *outfile) {
	/* print buffer to outfile but zero bit 8 of each char */
		int buflen;
		int goodcols, j;
		char thechar;
		int outerr;

		buflen = strlen(buffer);
		/* printf("strlen is %i, first chars are: ->%c%c%c<-\n", buflen, buffer[0], buffer[1], buffer[2]); */
		/* string longer than desired columns to remove */
		for (j=0;j<buflen;j++) {
			if ((unsigned char)buffer[j]==0x8D) {
			buffer[j]=0x20; /* Wordstar marker, remove it? */
			/* there may be other WS char's to remove, convert */
			/* printf("."); */
			}
			buffer[j]= buffer[j] & 0x7F;
			/* clear MSB, note all control chars unaffected */
		}

		/* printf("%s",buffer);  print to screen */
		if (fprintf(outfile, buffer, "%s")== EOF) {
			printf("write error or EOF on output file\n");
			return -1;
		}
		return 0;
}

int main(int argc,char *argv[])
{
	int option; /* index of options in command line */
	FILE *infile;
	FILE *outfile;
	char filename[80]; /* look for this file */
	char outname[85];
	int fnamelen; /* length of filename */
	char buffer[512+80];
	int bufind, buflen; /*index into buffer and length of string */
	int i, j, founddot;
	int namepos=0; /*location of filename in imagefile*/
	int cols, goodcols; /* number of left columns to delete, correct cols with tabs=8 */
	int overwrite; /* true 1 or false 0 to overwrite output file*/


	if (argc == 1) {
		/* If no arguments we call the Usage routine and exit */
		Usage(argv[0]);
		return 1;
	}
	/* handle the program options */

	option = HandleOptions(argc,argv);
	/* returns -1 on error, 0 if help request or index to first filename*/
	if (option < 1) return -1; /* error */
	/*otherwise see HandleOption for syntax */
	printf("option 1 is filename %s\n", argv[1]);

	/* process count of columns */
	cols = 0;

	/* process filename to find */
	fnamelen = strlen(argv[1]);
	if (fnamelen < 80) strcpy(filename, argv[1]); else {
		fprintf(stderr,"filename too long  %s\n", argv[1]);
		return -1;
	} /* else filetofindname is filename to look for AND output file */
	printf("input filename is *%s*\n", filename);

	/* create filename.asm for output, remove any other extension */
	founddot = 0;
	for (i=0;i<fnamelen;i++) {
		outname[i]=filename[i];
		if (outname[i]=='.') {
			founddot = 1;
			strcpy(outname+i+1, "8\0");
			break;
		}
	}
	if (founddot==0) strcpy(outname+fnamelen, ".8\n");
	printf("Output filename is *%s*\n",outname);


	/* open input  file for read */
	infile = fopen(filename,"r");
	if (infile == 0) {
		fprintf(stderr,"input file %s not found\n", filename);
		return -1;
	}

	printf("main: past openfile input file\n");


	/* open output file for read to see if exists */
	overwrite = 1;
	outfile = fopen(outname,"r");
	if (outfile != 0) { /* it exists */
		fprintf(stderr,"output file %s exists, overwrite.\n", outname);
		/* get yes or no input, set overwrite 1 for yes 0 for no */
		/* close output file either way */
		if (fclose (outfile)!= 0) {
			fprintf(stderr,"output file opened for read %s not closed\n", outname);
			return -1;
		}
	} /* else output file does not exist, we will open it below */

	/* if no overwrite close files and exit*/
	if (overwrite == 0) {
		fprintf(stderr,"no overwrite, close and exit\n");
		fclose (infile);
		return -1;
	}

	/* if yes to overwrite, or new file, open for write and go on*/
	outfile = fopen(outname,"w");
	if (outfile == 0) {
		fprintf(stderr,"output file %s not found\n", outname);
		return -1;
		}

	printf("main: past openfile output file\n");

	/* read line by line, strip 8th bit, spit out */

	namepos = 0; buffer[0]=0;
	while (1) {
		fgets(buffer, 512, infile);
		if (buffer == NULL) {
			fprintf(stderr,"input file read error\n");
			namepos = -1;
			break;
		}
		if (feof(infile)) {
			printf("\nEOF after %i lines\n",namepos);
			break;
		}
		if (printbuf(buffer,cols,outfile) != 0) break;
		namepos = namepos + 1;
		/* printf("."); /*show a trail*/
	}

	/* close files */
	if (fclose (infile)!=0) {
		fprintf(stderr,"input file %s not closed\n", argv[option]);
		return -1;
	}

	if (fclose (outfile)!=0) {
		fprintf(stderr,"output file %s not closed\n", outname);
		return -1;
	}
	printf("main: past closefile input & output file\n");
	return 0;
}
